# 练习 46：`blog`

> 原文：[Exercise 46: blog](https://learncodethehardway.org/more-python-book/ex46.html)

> 译者：[飞龙](https://github.com/wizardforcel)

> 协议：[CC BY-NC-SA 4.0](http://creativecommons.org/licenses/by-nc-sa/4.0/)

> 自豪地采用[谷歌翻译](https://translate.google.cn/)

你应该按照本节开头的描述编写流程主题，你应该将流程列出并做好准备。为了起步，我们将为本节的其余部分提供一个名为`blog`的全新工具作为热身。

你应该慢慢参与这个项目，尽量不要赶时间。你的目标不是成为快速的程序员。通过系统地缓慢起步，你最好缓慢、流畅地建立速度，直到你的工作方式成为第二本能。如果你总是赶时间，那么你会粗心。

确保将你的笔记放在手边，并跟踪你的工作的实际情况和指标。你正在试图看看是否有一个适合你的流程，作为稍后的工作方式。并不是所有的方法一直有用，这就是为什么我试图教你各种工作策略，不同的程序员使用它们。如果你做这个项目，你发现你做的事情没有起作用，那么你的笔记将帮助你找出原因。在下一个项目中更改它，看看其它的东西是否效果更好。

## 挑战练习

我让你编写一个名为`blog`的简单的命令行博客工具。这是一个非常有创意的项目名称，用于一个有创意的项目。博客是一些早期程序员编写的第一个项目，但是你的项目将在本地生成博客，然后使用另一个名为`rsync`的工具将其发送到服务器。以下是此练习的要求：

+   如果你不知道什么是博客，那么你应该去创建一个，然后尝试一下。有很多平台，但你可能会喜欢 Wordpress 或 Tumblr。只需使用它一会儿，并记下你可能想要复制的功能。不要太疯狂了。
+   你将要学习如何使用模板系统来设计 HTML 页面。我建议你使用 [mako](http://www.makotemplates.org/) 或 [jinja](http://jinja.pocoo.org/) 模板系统。这些系统允许你制作模板 HTML 文件，然后你可以根据用户放置在目录中的文本文件，将真实内容放入。
+   你将要使用 Markdown 作为你的博客格式，因此请为你的项目安装 [markdown](https://pypi.python.org/pypi/Markdown) 库。
+   你的博客将是一个静态文件博客，因此你将需要使用`python -m SimpleHTTPServer 8000`，就像[`SimpleHTTPServer`](https://docs.python.org/2/library/simplehttpserver.html)指南中演示的那样。这会把转储目录中的文件提供给浏览器。
+   你需要一个名为`blog`的命令行工具，来处理他人的博客。
+   在你起步之前，请考虑你的博客工具所做的所有事情，然后设计所需的所有命令及其参数。然后查看`docopt`项目，来实现这些命令。
+   你应该使用 [mock](https://pypi.python.org/pypi/mock) 来模拟你需要测试的东西，特别是错误情况。参考我在第三部分和第五部分中，我如何使用`mock`。
+   除此之外，你可以按照自己的意愿，随意开发这个`blog`工具。变得有创造力。所有要做的事情是，博客是以某种方式创建的，然后我可以放在要查看的服务器上。

最后，我会使用`rsync`将这样的博客放到网上，使用下列命令：

```
rsync -azv dist/* myserver.com:/var/www/myblog/
```

这可能更高级，但这可能是一个好时机，来学习如何部署静态文件。这里有一个研究性学习，也谈到如何使用亚马逊 S3 来实现它。

## 研究性学习

+   将静态文件部署到你自己的服务器是所有的事情，也很有趣，但如果`blog`工具适用于 Amazon S3 不是更好吗？有一个名为`boto3`的项目，将为你提供你所需的一切，使`blog`实现它。
+   编写一个`blog serve`命令，它使用`SimpleHTTPServer`类来简单部署博客，而不是单独生成博客。
